import{s as me,f as ue,n as he,o as ce}from"../chunks/scheduler.37c15a92.js";import{S as ge,i as xe,g as l,s as o,r as ve,A as de,h as a,f as n,c as s,j as fe,u as we,x as r,k as m,y as _e,a as i,v as Te,d as Le,t as He,w as Me}from"../chunks/index.7cb9c9b8.js";import{H as be}from"../chunks/Heading.d3928e2a.js";function ye(N){let p,P,C,k,h,$,c,O="Finally, before looking at the different methods to solve Reinforcement Learning problems, we must cover one more very important topic: <em>the exploration/exploitation trade-off.</em>",q,g,Q="<li><em>Exploration</em> is exploring the environment by trying random actions in order to <strong>find more information about the environment.</strong></li> <li><em>Exploitation</em> is <strong>exploiting known information to maximize the reward.</strong></li>",z,x,V="Remember, the goal of our RL agent is to maximize the expected cumulative reward. However, <strong>we can fall into a common trap</strong>.",I,v,X="Let’s take an example:",j,u,Z,R,d,ee="In this game, our mouse can have an <strong>infinite amount of small cheese</strong> (+1 each). But at the top of the maze, there is a gigantic sum of cheese (+1000).",S,w,te="However, if we only focus on exploitation, our agent will never reach the gigantic sum of cheese. Instead, it will only exploit <strong>the nearest source of rewards,</strong> even if this source is small (exploitation).",U,_,ne="But if our agent does a little bit of exploration, it can <strong>discover the big reward</strong> (the pile of big cheese).",A,T,ie="This is what we call the exploration/exploitation trade-off. We need to balance how much we <strong>explore the environment</strong> and how much we <strong>exploit what we know about the environment.</strong>",B,L,le="Therefore, we must <strong>define a rule that helps to handle this trade-off</strong>. We’ll see the different ways to handle it in the future units.",G,H,oe="If it’s still confusing, <strong>think of a real problem: the choice of picking a restaurant:</strong>",F,M,ae='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/exp_2.jpg" alt="Exploration"/> <figcaption>Source: <a href="https://inst.eecs.berkeley.edu/~cs188/sp20/assets/lecture/lec15_6up.pdf">Berkley AI Course</a></figcaption>',W,b,se="<li><em>Exploitation</em>: You go to the same one that you know is good every day and <strong>take the risk to miss another better restaurant.</strong></li> <li><em>Exploration</em>: Try restaurants you never went to before, with the risk of having a bad experience <strong>but the probable opportunity of a fantastic experience.</strong></li>",Y,y,re="To recap:",D,f,pe,J,E,K;return h=new be({props:{title:"The Exploration/Exploitation trade-off",local:"exp-exp-tradeoff",headingTag:"h1"}}),{c(){p=l("meta"),P=o(),C=l("p"),k=o(),ve(h.$$.fragment),$=o(),c=l("p"),c.innerHTML=O,q=o(),g=l("ul"),g.innerHTML=Q,z=o(),x=l("p"),x.innerHTML=V,I=o(),v=l("p"),v.textContent=X,j=o(),u=l("img"),R=o(),d=l("p"),d.innerHTML=ee,S=o(),w=l("p"),w.innerHTML=te,U=o(),_=l("p"),_.innerHTML=ne,A=o(),T=l("p"),T.innerHTML=ie,B=o(),L=l("p"),L.innerHTML=le,G=o(),H=l("p"),H.innerHTML=oe,F=o(),M=l("figure"),M.innerHTML=ae,W=o(),b=l("ul"),b.innerHTML=se,Y=o(),y=l("p"),y.textContent=re,D=o(),f=l("img"),J=o(),E=l("p"),this.h()},l(e){const t=de("svelte-u9bgzb",document.head);p=a(t,"META",{name:!0,content:!0}),t.forEach(n),P=s(e),C=a(e,"P",{}),fe(C).forEach(n),k=s(e),we(h.$$.fragment,e),$=s(e),c=a(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-fbv3pl"&&(c.innerHTML=O),q=s(e),g=a(e,"UL",{"data-svelte-h":!0}),r(g)!=="svelte-nc85ql"&&(g.innerHTML=Q),z=s(e),x=a(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-2jh1qs"&&(x.innerHTML=V),I=s(e),v=a(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1wtngfz"&&(v.textContent=X),j=s(e),u=a(e,"IMG",{src:!0,alt:!0,width:!0}),R=s(e),d=a(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1kw5ynv"&&(d.innerHTML=ee),S=s(e),w=a(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-qt6w4m"&&(w.innerHTML=te),U=s(e),_=a(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-16dhxd1"&&(_.innerHTML=ne),A=s(e),T=a(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-13goax7"&&(T.innerHTML=ie),B=s(e),L=a(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-65jqh4"&&(L.innerHTML=le),G=s(e),H=a(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1qfk4tu"&&(H.innerHTML=oe),F=s(e),M=a(e,"FIGURE",{"data-svelte-h":!0}),r(M)!=="svelte-sgn18n"&&(M.innerHTML=ae),W=s(e),b=a(e,"UL",{"data-svelte-h":!0}),r(b)!=="svelte-1yngr8f"&&(b.innerHTML=se),Y=s(e),y=a(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-mz2ztc"&&(y.textContent=re),D=s(e),f=a(e,"IMG",{src:!0,alt:!0,width:!0}),J=s(e),E=a(e,"P",{}),fe(E).forEach(n),this.h()},h(){m(p,"name","hf:doc:metadata"),m(p,"content",Ce),ue(u.src,Z="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/exp_1.jpg")||m(u,"src",Z),m(u,"alt","Exploration"),m(u,"width","100%"),ue(f.src,pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/expexpltradeoff.jpg")||m(f,"src",pe),m(f,"alt","Exploration Exploitation Tradeoff"),m(f,"width","100%")},m(e,t){_e(document.head,p),i(e,P,t),i(e,C,t),i(e,k,t),Te(h,e,t),i(e,$,t),i(e,c,t),i(e,q,t),i(e,g,t),i(e,z,t),i(e,x,t),i(e,I,t),i(e,v,t),i(e,j,t),i(e,u,t),i(e,R,t),i(e,d,t),i(e,S,t),i(e,w,t),i(e,U,t),i(e,_,t),i(e,A,t),i(e,T,t),i(e,B,t),i(e,L,t),i(e,G,t),i(e,H,t),i(e,F,t),i(e,M,t),i(e,W,t),i(e,b,t),i(e,Y,t),i(e,y,t),i(e,D,t),i(e,f,t),i(e,J,t),i(e,E,t),K=!0},p:he,i(e){K||(Le(h.$$.fragment,e),K=!0)},o(e){He(h.$$.fragment,e),K=!1},d(e){e&&(n(P),n(C),n(k),n($),n(c),n(q),n(g),n(z),n(x),n(I),n(v),n(j),n(u),n(R),n(d),n(S),n(w),n(U),n(_),n(A),n(T),n(B),n(L),n(G),n(H),n(F),n(M),n(W),n(b),n(Y),n(y),n(D),n(f),n(J),n(E)),n(p),Me(h,e)}}}const Ce='{"title":"The Exploration/Exploitation trade-off","local":"exp-exp-tradeoff","sections":[],"depth":1}';function Ee(N){return ce(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends ge{constructor(p){super(),xe(this,p,Ee,ye,me,{})}}export{qe as component};
