import{s as Pa,f as h,n as Sa,o as Ia}from"../chunks/scheduler.37c15a92.js";import{S as ja,i as Ra,g as l,s as n,r as T,m as g,H as At,A as Ga,h as p,f as e,c as i,j as u,u as L,x as m,n as c,B as Et,k as r,y as o,a,v as M,d as Q,t as H,w as $}from"../chunks/index.7cb9c9b8.js";import{H as C}from"../chunks/Heading.d3928e2a.js";function Aa(Hs){let f,Ot,Ut,Ft,z,Dt,k,Nt,P,$s="Q-Learning is an <strong>off-policy value-based method that uses a TD approach to train its action-value function:</strong>",Bt,S,Cs="<li><em>Off-policy</em>: we’ll talk about that at the end of this unit.</li> <li><em>Value-based method</em>: finds the optimal policy indirectly by training a value or action-value function that will tell us <strong>the value of each state or each state-action pair.</strong></li> <li><em>TD approach:</em> <strong>updates its action-value function at each step instead of at the end of the episode.</strong></li>",Vt,I,zs="<strong>Q-Learning is the algorithm we use to train our Q-function</strong>, an <strong>action-value function</strong> that determines the value of being at a particular state and taking a specific action at that state.",Jt,j,ks='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function.jpg" alt="Q-function"/> <figcaption>Given a state and action, our Q Function outputs a state-action value (also called Q-value)</figcaption>',Kt,R,Ps="The <strong>Q comes from “the Quality” (the value) of that action at that state.</strong>",Xt,G,Ss="Let’s recap the difference between value and reward:",Yt,A,Is="<li>The <em>value of a state</em>, or a <em>state-action pair</em> is the expected cumulative reward our agent gets if it starts at this state (or state-action pair) and then acts accordingly to its policy.</li> <li>The <em>reward</em> is the <strong>feedback I get from the environment</strong> after performing an action at a state.</li>",Zt,E,js="Internally, our Q-function is encoded by <strong>a Q-table, a table where each cell corresponds to a state-action pair value.</strong> Think of this Q-table as <strong>the memory or cheat sheet of our Q-function.</strong>",te,U,Rs="Let’s go through an example of a maze.",ee,q,Gs,se,W,As="The Q-table is initialized. That’s why all values are = 0. This table <strong>contains, for each state and action, the corresponding state-action values.</strong>",ae,O,Es,ne,F,Us="Here we see that the <strong>state-action value of the initial state and going up is 0:</strong>",ie,D,qs,le,N,Ws="So: the Q-function uses a Q-table <strong>that has the value of each state-action pair.</strong> Given a state and action, <strong>our Q-function will search inside its Q-table to output the value.</strong>",pe,B,Os='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-function-2.jpg" alt="Q-function"/>',me,V,Fs="If we recap, <em>Q-Learning</em> <strong>is the RL algorithm that:</strong>",re,J,Ds="<li>Trains a <em>Q-function</em> (an <strong>action-value function</strong>), which internally is a <strong>Q-table that contains all the state-action pair values.</strong></li> <li>Given a state and action, our Q-function <strong>will search its Q-table for the corresponding value.</strong></li> <li>When the training is done, <strong>we have an optimal Q-function, which means we have optimal Q-table.</strong></li> <li>And if we <strong>have an optimal Q-function</strong>, we <strong>have an optimal policy</strong> since we <strong>know the best action to take at each state.</strong></li>",oe,K,Ns,ge,X,Bs="In the beginning, <strong>our Q-table is useless since it gives arbitrary values for each state-action pair</strong> (most of the time, we initialize the Q-table to 0). As the agent <strong>explores the environment and we update the Q-table, it will give us a better and better approximation</strong> to the optimal policy.",ce,w,Vs='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-1.jpg" alt="Q-learning"/> <figcaption>We see here that with the training, our Q-table is better since, thanks to it, we can know the value of each state-action pair.</figcaption>',he,Y,Js="Now that we understand what Q-Learning, Q-functions, and Q-tables are, <strong>let’s dive deeper into the Q-Learning algorithm</strong>.",ue,Z,fe,tt,Ks="This is the Q-Learning pseudocode; let’s study each part and <strong>see how it works with a simple example before implementing it.</strong> Don’t be intimidated by it, it’s simpler than it looks! We’ll go over each step.",ve,et,Xs,de,st,we,at,Ys,ye,nt,Zs="We need to initialize the Q-table for each state-action pair. <strong>Most of the time, we initialize with values of 0.</strong>",xe,it,_e,lt,ta,be,pt,ea="The epsilon-greedy strategy is a policy that handles the exploration/exploitation trade-off.",Te,mt,sa="The idea is that, with an initial value of ɛ = 1.0:",Le,rt,aa="<li><em>With probability 1 — ɛ</em> : we do <strong>exploitation</strong> (aka our agent selects the action with the highest state-action pair value).</li> <li>With probability ɛ: <strong>we do exploration</strong> (trying random action).</li>",Me,ot,na="At the beginning of the training, <strong>the probability of doing exploration will be huge since ɛ is very high, so most of the time, we’ll explore.</strong> But as the training goes on, and consequently our <strong>Q-table gets better and better in its estimations, we progressively reduce the epsilon value</strong> since we will need less and less exploration and more exploitation.",Qe,gt,ia,He,ct,$e,ht,la,Ce,ut,ze,ft,pa="Remember that in TD Learning, we update our policy or value function (depending on the RL method we choose) <strong>after one step of the interaction.</strong>",ke,y,ws,vt,ys,Pe,Qa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Se,xs,Ie,dt,ma,je,v,_s,Re,Ha='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ge,It,ra="update formula goes like this:",Ae,wt,oa,Ee,x,bs,Ue,$a='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',qe,We,_,yt,Ts,Oe,Ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo separator="true">,</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_t, A_t, R_{t+1}, S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Fe,Ls,jt,ga="To update our Q-value at a given state-action pair, we use the TD target.",De,xt,ca="How do we form the TD target?",Ne,b,d,Ms,Be,za='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ve,Je,ka='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ke,Qs,Rt,ha="To get the <strong>best state-action pair value</strong> for the next state, we use a greedy policy to select the next best action. Note that this is not an epsilon-greedy policy, this will always take the action with the highest state-action value.",Xe,_t,ua="Then when the update of this Q-value is done, we start in a new state and select our action <strong>using a epsilon-greedy policy again.</strong>",Ye,bt,fa="<strong>This is why we say that Q Learning is an off-policy algorithm.</strong>",Ze,Tt,ts,Lt,va="The difference is subtle:",es,Mt,da="<li><em>Off-policy</em>: using <strong>a different policy for acting (inference) and updating (training).</strong></li>",ss,Qt,wa="For instance, with Q-Learning, the epsilon-greedy policy (acting policy), is different from the greedy policy that is <strong>used to select the best next-state action value to update our Q-value (updating policy).</strong>",as,Ht,ya='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-1.jpg" alt="Off-on policy"/> <figcaption>Acting Policy</figcaption>',ns,$t,xa="Is different from the policy we use during the training part:",is,Ct,_a='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-2.jpg" alt="Off-on policy"/> <figcaption>Updating policy</figcaption>',ls,zt,ba="<li><em>On-policy:</em> using the <strong>same policy for acting and updating.</strong></li>",ps,kt,Ta="For instance, with Sarsa, another value-based algorithm, <strong>the epsilon-greedy policy selects the next state-action pair, not a greedy policy.</strong>",ms,Pt,La='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-3.jpg" alt="Off-on policy"/> <figcaption>Sarsa</figcaption>',rs,St,Ma='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/off-on-4.jpg" alt="Off-on policy"/>',os,qt,gs;return z=new C({props:{title:"Introducing Q-Learning",local:"q-learning",headingTag:"h1"}}),k=new C({props:{title:"What is Q-Learning?",local:"what-is-q-learning",headingTag:"h2"}}),Z=new C({props:{title:"The Q-Learning algorithm",local:"q-learning-algo",headingTag:"h2"}}),st=new C({props:{title:"Step 1: We initialize the Q-table",local:"step1",headingTag:"h3"}}),it=new C({props:{title:"Step 2: Choose an action using the epsilon-greedy strategy",local:"step2",headingTag:"h3"}}),ct=new C({props:{title:"Step 3: Perform action At, get reward Rt+1 and next state St+1",local:"step3",headingTag:"h3"}}),ut=new C({props:{title:"Step 4: Update Q(St, At)",local:"step4",headingTag:"h3"}}),Tt=new C({props:{title:"Off-policy vs On-policy",local:"off-vs-on",headingTag:"h2"}}),{c(){f=l("meta"),Ot=n(),Ut=l("p"),Ft=n(),T(z.$$.fragment),Dt=n(),T(k.$$.fragment),Nt=n(),P=l("p"),P.innerHTML=$s,Bt=n(),S=l("ul"),S.innerHTML=Cs,Vt=n(),I=l("p"),I.innerHTML=zs,Jt=n(),j=l("figure"),j.innerHTML=ks,Kt=n(),R=l("p"),R.innerHTML=Ps,Xt=n(),G=l("p"),G.textContent=Ss,Yt=n(),A=l("ul"),A.innerHTML=Is,Zt=n(),E=l("p"),E.innerHTML=js,te=n(),U=l("p"),U.textContent=Rs,ee=n(),q=l("img"),se=n(),W=l("p"),W.innerHTML=As,ae=n(),O=l("img"),ne=n(),F=l("p"),F.innerHTML=Us,ie=n(),D=l("img"),le=n(),N=l("p"),N.innerHTML=Ws,pe=n(),B=l("figure"),B.innerHTML=Os,me=n(),V=l("p"),V.innerHTML=Fs,re=n(),J=l("ul"),J.innerHTML=Ds,oe=n(),K=l("img"),ge=n(),X=l("p"),X.innerHTML=Bs,ce=n(),w=l("figure"),w.innerHTML=Vs,he=n(),Y=l("p"),Y.innerHTML=Js,ue=n(),T(Z.$$.fragment),fe=n(),tt=l("p"),tt.innerHTML=Ks,ve=n(),et=l("img"),de=n(),T(st.$$.fragment),we=n(),at=l("img"),ye=n(),nt=l("p"),nt.innerHTML=Zs,xe=n(),T(it.$$.fragment),_e=n(),lt=l("img"),be=n(),pt=l("p"),pt.textContent=ea,Te=n(),mt=l("p"),mt.textContent=sa,Le=n(),rt=l("ul"),rt.innerHTML=aa,Me=n(),ot=l("p"),ot.innerHTML=na,Qe=n(),gt=l("img"),He=n(),T(ct.$$.fragment),$e=n(),ht=l("img"),Ce=n(),T(ut.$$.fragment),ze=n(),ft=l("p"),ft.innerHTML=pa,ke=n(),y=l("p"),ws=g("To produce our TD target, "),vt=l("strong"),ys=g("we used the immediate reward "),Pe=new At(!1),Se=g(" plus the discounted value of the next state"),xs=g(", computed by finding the action that maximizes the current Q-function at the next state. (We call that bootstrap)."),Ie=n(),dt=l("img"),je=n(),v=l("p"),_s=g("Therefore, our "),Re=new At(!1),Ge=g(" "),It=l("strong"),It.textContent=ra,Ae=n(),wt=l("img"),Ee=n(),x=l("p"),bs=g("This means that to update our "),Ue=new At(!1),qe=g(":"),We=n(),_=l("ul"),yt=l("li"),Ts=g("We need "),Oe=new At(!1),Fe=g("."),Ls=n(),jt=l("li"),jt.textContent=ga,De=n(),xt=l("p"),xt.textContent=ca,Ne=n(),b=l("ol"),d=l("li"),Ms=g("We obtain the reward "),Be=new At(!1),Ve=g(" after taking the action "),Je=new At(!1),Ke=g("."),Qs=n(),Rt=l("li"),Rt.innerHTML=ha,Xe=n(),_t=l("p"),_t.innerHTML=ua,Ye=n(),bt=l("p"),bt.innerHTML=fa,Ze=n(),T(Tt.$$.fragment),ts=n(),Lt=l("p"),Lt.textContent=va,es=n(),Mt=l("ul"),Mt.innerHTML=da,ss=n(),Qt=l("p"),Qt.innerHTML=wa,as=n(),Ht=l("figure"),Ht.innerHTML=ya,ns=n(),$t=l("p"),$t.textContent=xa,is=n(),Ct=l("figure"),Ct.innerHTML=_a,ls=n(),zt=l("ul"),zt.innerHTML=ba,ps=n(),kt=l("p"),kt.innerHTML=Ta,ms=n(),Pt=l("figure"),Pt.innerHTML=La,rs=n(),St=l("figure"),St.innerHTML=Ma,os=n(),qt=l("p"),this.h()},l(t){const s=Ga("svelte-u9bgzb",document.head);f=p(s,"META",{name:!0,content:!0}),s.forEach(e),Ot=i(t),Ut=p(t,"P",{}),u(Ut).forEach(e),Ft=i(t),L(z.$$.fragment,t),Dt=i(t),L(k.$$.fragment,t),Nt=i(t),P=p(t,"P",{"data-svelte-h":!0}),m(P)!=="svelte-vs38b5"&&(P.innerHTML=$s),Bt=i(t),S=p(t,"UL",{"data-svelte-h":!0}),m(S)!=="svelte-10wsnaz"&&(S.innerHTML=Cs),Vt=i(t),I=p(t,"P",{"data-svelte-h":!0}),m(I)!=="svelte-1bdys1r"&&(I.innerHTML=zs),Jt=i(t),j=p(t,"FIGURE",{"data-svelte-h":!0}),m(j)!=="svelte-5lmfx0"&&(j.innerHTML=ks),Kt=i(t),R=p(t,"P",{"data-svelte-h":!0}),m(R)!=="svelte-crnsdp"&&(R.innerHTML=Ps),Xt=i(t),G=p(t,"P",{"data-svelte-h":!0}),m(G)!=="svelte-1ubk9oh"&&(G.textContent=Ss),Yt=i(t),A=p(t,"UL",{"data-svelte-h":!0}),m(A)!=="svelte-1nda8m2"&&(A.innerHTML=Is),Zt=i(t),E=p(t,"P",{"data-svelte-h":!0}),m(E)!=="svelte-gdw4y7"&&(E.innerHTML=js),te=i(t),U=p(t,"P",{"data-svelte-h":!0}),m(U)!=="svelte-1cli1ai"&&(U.textContent=Rs),ee=i(t),q=p(t,"IMG",{src:!0,alt:!0}),se=i(t),W=p(t,"P",{"data-svelte-h":!0}),m(W)!=="svelte-7yqtiu"&&(W.innerHTML=As),ae=i(t),O=p(t,"IMG",{src:!0,alt:!0}),ne=i(t),F=p(t,"P",{"data-svelte-h":!0}),m(F)!=="svelte-1v5c7t0"&&(F.innerHTML=Us),ie=i(t),D=p(t,"IMG",{src:!0,alt:!0}),le=i(t),N=p(t,"P",{"data-svelte-h":!0}),m(N)!=="svelte-1ptm42n"&&(N.innerHTML=Ws),pe=i(t),B=p(t,"FIGURE",{"data-svelte-h":!0}),m(B)!=="svelte-1wlsy73"&&(B.innerHTML=Os),me=i(t),V=p(t,"P",{"data-svelte-h":!0}),m(V)!=="svelte-18kluj9"&&(V.innerHTML=Fs),re=i(t),J=p(t,"UL",{"data-svelte-h":!0}),m(J)!=="svelte-rhztxe"&&(J.innerHTML=Ds),oe=i(t),K=p(t,"IMG",{src:!0,alt:!0}),ge=i(t),X=p(t,"P",{"data-svelte-h":!0}),m(X)!=="svelte-upi7hl"&&(X.innerHTML=Bs),ce=i(t),w=p(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(w)!=="svelte-qceb0"&&(w.innerHTML=Vs),he=i(t),Y=p(t,"P",{"data-svelte-h":!0}),m(Y)!=="svelte-1jxrnuj"&&(Y.innerHTML=Js),ue=i(t),L(Z.$$.fragment,t),fe=i(t),tt=p(t,"P",{"data-svelte-h":!0}),m(tt)!=="svelte-1fdmnfq"&&(tt.innerHTML=Ks),ve=i(t),et=p(t,"IMG",{src:!0,alt:!0}),de=i(t),L(st.$$.fragment,t),we=i(t),at=p(t,"IMG",{src:!0,alt:!0}),ye=i(t),nt=p(t,"P",{"data-svelte-h":!0}),m(nt)!=="svelte-hvlw74"&&(nt.innerHTML=Zs),xe=i(t),L(it.$$.fragment,t),_e=i(t),lt=p(t,"IMG",{src:!0,alt:!0}),be=i(t),pt=p(t,"P",{"data-svelte-h":!0}),m(pt)!=="svelte-1rsicc3"&&(pt.textContent=ea),Te=i(t),mt=p(t,"P",{"data-svelte-h":!0}),m(mt)!=="svelte-1p8nnff"&&(mt.textContent=sa),Le=i(t),rt=p(t,"UL",{"data-svelte-h":!0}),m(rt)!=="svelte-1qbe9yz"&&(rt.innerHTML=aa),Me=i(t),ot=p(t,"P",{"data-svelte-h":!0}),m(ot)!=="svelte-vlbioi"&&(ot.innerHTML=na),Qe=i(t),gt=p(t,"IMG",{src:!0,alt:!0}),He=i(t),L(ct.$$.fragment,t),$e=i(t),ht=p(t,"IMG",{src:!0,alt:!0}),Ce=i(t),L(ut.$$.fragment,t),ze=i(t),ft=p(t,"P",{"data-svelte-h":!0}),m(ft)!=="svelte-19iw7lu"&&(ft.innerHTML=pa),ke=i(t),y=p(t,"P",{});var cs=u(y);ws=c(cs,"To produce our TD target, "),vt=p(cs,"STRONG",{});var hs=u(vt);ys=c(hs,"we used the immediate reward "),Pe=Et(hs,!1),Se=c(hs," plus the discounted value of the next state"),hs.forEach(e),xs=c(cs,", computed by finding the action that maximizes the current Q-function at the next state. (We call that bootstrap)."),cs.forEach(e),Ie=i(t),dt=p(t,"IMG",{src:!0,alt:!0}),je=i(t),v=p(t,"P",{});var Wt=u(v);_s=c(Wt,"Therefore, our "),Re=Et(Wt,!1),Ge=c(Wt," "),It=p(Wt,"STRONG",{"data-svelte-h":!0}),m(It)!=="svelte-12kejy4"&&(It.textContent=ra),Wt.forEach(e),Ae=i(t),wt=p(t,"IMG",{src:!0,alt:!0}),Ee=i(t),x=p(t,"P",{});var us=u(x);bs=c(us,"This means that to update our "),Ue=Et(us,!1),qe=c(us,":"),us.forEach(e),We=i(t),_=p(t,"UL",{});var fs=u(_);yt=p(fs,"LI",{});var vs=u(yt);Ts=c(vs,"We need "),Oe=Et(vs,!1),Fe=c(vs,"."),vs.forEach(e),Ls=i(fs),jt=p(fs,"LI",{"data-svelte-h":!0}),m(jt)!=="svelte-1ihnbvx"&&(jt.textContent=ga),fs.forEach(e),De=i(t),xt=p(t,"P",{"data-svelte-h":!0}),m(xt)!=="svelte-1dxw0aw"&&(xt.textContent=ca),Ne=i(t),b=p(t,"OL",{});var ds=u(b);d=p(ds,"LI",{});var Gt=u(d);Ms=c(Gt,"We obtain the reward "),Be=Et(Gt,!1),Ve=c(Gt," after taking the action "),Je=Et(Gt,!1),Ke=c(Gt,"."),Gt.forEach(e),Qs=i(ds),Rt=p(ds,"LI",{"data-svelte-h":!0}),m(Rt)!=="svelte-ncl2c6"&&(Rt.innerHTML=ha),ds.forEach(e),Xe=i(t),_t=p(t,"P",{"data-svelte-h":!0}),m(_t)!=="svelte-yt04ce"&&(_t.innerHTML=ua),Ye=i(t),bt=p(t,"P",{"data-svelte-h":!0}),m(bt)!=="svelte-rw0dnq"&&(bt.innerHTML=fa),Ze=i(t),L(Tt.$$.fragment,t),ts=i(t),Lt=p(t,"P",{"data-svelte-h":!0}),m(Lt)!=="svelte-1660nrr"&&(Lt.textContent=va),es=i(t),Mt=p(t,"UL",{"data-svelte-h":!0}),m(Mt)!=="svelte-jbg8q"&&(Mt.innerHTML=da),ss=i(t),Qt=p(t,"P",{"data-svelte-h":!0}),m(Qt)!=="svelte-5r7jq0"&&(Qt.innerHTML=wa),as=i(t),Ht=p(t,"FIGURE",{"data-svelte-h":!0}),m(Ht)!=="svelte-2uzk1v"&&(Ht.innerHTML=ya),ns=i(t),$t=p(t,"P",{"data-svelte-h":!0}),m($t)!=="svelte-1xs5vi8"&&($t.textContent=xa),is=i(t),Ct=p(t,"FIGURE",{"data-svelte-h":!0}),m(Ct)!=="svelte-2rk9mg"&&(Ct.innerHTML=_a),ls=i(t),zt=p(t,"UL",{"data-svelte-h":!0}),m(zt)!=="svelte-19dbnnc"&&(zt.innerHTML=ba),ps=i(t),kt=p(t,"P",{"data-svelte-h":!0}),m(kt)!=="svelte-3lwzbr"&&(kt.innerHTML=Ta),ms=i(t),Pt=p(t,"FIGURE",{"data-svelte-h":!0}),m(Pt)!=="svelte-1qn38id"&&(Pt.innerHTML=La),rs=i(t),St=p(t,"FIGURE",{"data-svelte-h":!0}),m(St)!=="svelte-1e5hwrp"&&(St.innerHTML=Ma),os=i(t),qt=p(t,"P",{}),u(qt).forEach(e),this.h()},h(){r(f,"name","hf:doc:metadata"),r(f,"content",Ea),h(q.src,Gs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-1.jpg")||r(q,"src",Gs),r(q,"alt","Maze example"),h(O.src,Es="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-2.jpg")||r(O,"src",Es),r(O,"alt","Maze example"),h(D.src,qs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-3.jpg")||r(D,"src",qs),r(D,"alt","Maze example"),h(K.src,Ns="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/link-value-policy.jpg")||r(K,"src",Ns),r(K,"alt","Link value policy"),r(w,"class","image table text-center m-0 w-full"),h(et.src,Xs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-2.jpg")||r(et,"src",Xs),r(et,"alt","Q-learning"),h(at.src,Ys="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-3.jpg")||r(at,"src",Ys),r(at,"alt","Q-learning"),h(lt.src,ta="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-4.jpg")||r(lt,"src",ta),r(lt,"alt","Q-learning"),h(gt.src,ia="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-5.jpg")||r(gt,"src",ia),r(gt,"alt","Q-learning"),h(ht.src,la="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-6.jpg")||r(ht,"src",la),r(ht,"alt","Q-learning"),Pe.a=Se,h(dt.src,ma="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-7.jpg")||r(dt,"src",ma),r(dt,"alt","Q-learning"),Re.a=Ge,h(wt.src,oa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Q-learning-8.jpg")||r(wt,"src",oa),r(wt,"alt","Q-learning"),Ue.a=qe,Oe.a=Fe,Be.a=Ve,Je.a=Ke},m(t,s){o(document.head,f),a(t,Ot,s),a(t,Ut,s),a(t,Ft,s),M(z,t,s),a(t,Dt,s),M(k,t,s),a(t,Nt,s),a(t,P,s),a(t,Bt,s),a(t,S,s),a(t,Vt,s),a(t,I,s),a(t,Jt,s),a(t,j,s),a(t,Kt,s),a(t,R,s),a(t,Xt,s),a(t,G,s),a(t,Yt,s),a(t,A,s),a(t,Zt,s),a(t,E,s),a(t,te,s),a(t,U,s),a(t,ee,s),a(t,q,s),a(t,se,s),a(t,W,s),a(t,ae,s),a(t,O,s),a(t,ne,s),a(t,F,s),a(t,ie,s),a(t,D,s),a(t,le,s),a(t,N,s),a(t,pe,s),a(t,B,s),a(t,me,s),a(t,V,s),a(t,re,s),a(t,J,s),a(t,oe,s),a(t,K,s),a(t,ge,s),a(t,X,s),a(t,ce,s),a(t,w,s),a(t,he,s),a(t,Y,s),a(t,ue,s),M(Z,t,s),a(t,fe,s),a(t,tt,s),a(t,ve,s),a(t,et,s),a(t,de,s),M(st,t,s),a(t,we,s),a(t,at,s),a(t,ye,s),a(t,nt,s),a(t,xe,s),M(it,t,s),a(t,_e,s),a(t,lt,s),a(t,be,s),a(t,pt,s),a(t,Te,s),a(t,mt,s),a(t,Le,s),a(t,rt,s),a(t,Me,s),a(t,ot,s),a(t,Qe,s),a(t,gt,s),a(t,He,s),M(ct,t,s),a(t,$e,s),a(t,ht,s),a(t,Ce,s),M(ut,t,s),a(t,ze,s),a(t,ft,s),a(t,ke,s),a(t,y,s),o(y,ws),o(y,vt),o(vt,ys),Pe.m(Qa,vt),o(vt,Se),o(y,xs),a(t,Ie,s),a(t,dt,s),a(t,je,s),a(t,v,s),o(v,_s),Re.m(Ha,v),o(v,Ge),o(v,It),a(t,Ae,s),a(t,wt,s),a(t,Ee,s),a(t,x,s),o(x,bs),Ue.m($a,x),o(x,qe),a(t,We,s),a(t,_,s),o(_,yt),o(yt,Ts),Oe.m(Ca,yt),o(yt,Fe),o(_,Ls),o(_,jt),a(t,De,s),a(t,xt,s),a(t,Ne,s),a(t,b,s),o(b,d),o(d,Ms),Be.m(za,d),o(d,Ve),Je.m(ka,d),o(d,Ke),o(b,Qs),o(b,Rt),a(t,Xe,s),a(t,_t,s),a(t,Ye,s),a(t,bt,s),a(t,Ze,s),M(Tt,t,s),a(t,ts,s),a(t,Lt,s),a(t,es,s),a(t,Mt,s),a(t,ss,s),a(t,Qt,s),a(t,as,s),a(t,Ht,s),a(t,ns,s),a(t,$t,s),a(t,is,s),a(t,Ct,s),a(t,ls,s),a(t,zt,s),a(t,ps,s),a(t,kt,s),a(t,ms,s),a(t,Pt,s),a(t,rs,s),a(t,St,s),a(t,os,s),a(t,qt,s),gs=!0},p:Sa,i(t){gs||(Q(z.$$.fragment,t),Q(k.$$.fragment,t),Q(Z.$$.fragment,t),Q(st.$$.fragment,t),Q(it.$$.fragment,t),Q(ct.$$.fragment,t),Q(ut.$$.fragment,t),Q(Tt.$$.fragment,t),gs=!0)},o(t){H(z.$$.fragment,t),H(k.$$.fragment,t),H(Z.$$.fragment,t),H(st.$$.fragment,t),H(it.$$.fragment,t),H(ct.$$.fragment,t),H(ut.$$.fragment,t),H(Tt.$$.fragment,t),gs=!1},d(t){t&&(e(Ot),e(Ut),e(Ft),e(Dt),e(Nt),e(P),e(Bt),e(S),e(Vt),e(I),e(Jt),e(j),e(Kt),e(R),e(Xt),e(G),e(Yt),e(A),e(Zt),e(E),e(te),e(U),e(ee),e(q),e(se),e(W),e(ae),e(O),e(ne),e(F),e(ie),e(D),e(le),e(N),e(pe),e(B),e(me),e(V),e(re),e(J),e(oe),e(K),e(ge),e(X),e(ce),e(w),e(he),e(Y),e(ue),e(fe),e(tt),e(ve),e(et),e(de),e(we),e(at),e(ye),e(nt),e(xe),e(_e),e(lt),e(be),e(pt),e(Te),e(mt),e(Le),e(rt),e(Me),e(ot),e(Qe),e(gt),e(He),e($e),e(ht),e(Ce),e(ze),e(ft),e(ke),e(y),e(Ie),e(dt),e(je),e(v),e(Ae),e(wt),e(Ee),e(x),e(We),e(_),e(De),e(xt),e(Ne),e(b),e(Xe),e(_t),e(Ye),e(bt),e(Ze),e(ts),e(Lt),e(es),e(Mt),e(ss),e(Qt),e(as),e(Ht),e(ns),e($t),e(is),e(Ct),e(ls),e(zt),e(ps),e(kt),e(ms),e(Pt),e(rs),e(St),e(os),e(qt)),e(f),$(z,t),$(k,t),$(Z,t),$(st,t),$(it,t),$(ct,t),$(ut,t),$(Tt,t)}}}const Ea='{"title":"Introducing Q-Learning","local":"q-learning","sections":[{"title":"What is Q-Learning?","local":"what-is-q-learning","sections":[],"depth":2},{"title":"The Q-Learning algorithm","local":"q-learning-algo","sections":[{"title":"Step 1: We initialize the Q-table","local":"step1","sections":[],"depth":3},{"title":"Step 2: Choose an action using the epsilon-greedy strategy","local":"step2","sections":[],"depth":3},{"title":"Step 3: Perform action At, get reward Rt+1 and next state St+1","local":"step3","sections":[],"depth":3},{"title":"Step 4: Update Q(St, At)","local":"step4","sections":[],"depth":3}],"depth":2},{"title":"Off-policy vs On-policy","local":"off-vs-on","sections":[],"depth":2}],"depth":1}';function Ua(Hs){return Ia(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fa extends ja{constructor(f){super(),Ra(this,f,Ua,Aa,Pa,{})}}export{Fa as component};
