import{s as qe,f as g,n as je,o as Re}from"../chunks/scheduler.37c15a92.js";import{S as Be,i as Ue,g as i,s as n,r as f,m as at,H as pe,A as Ne,h as p,f as s,c as l,j as lt,u as v,x as r,n as nt,B as me,k as m,y as c,a,v as d,d as x,t as w,w as _}from"../chunks/index.7cb9c9b8.js";import{H as $}from"../chunks/Heading.d3928e2a.js";function We(re){let o,mt,it,rt,y,gt,M,ge="To better understand Q-Learning, let’s take a simple example:",ot,b,oe,ct,T,ce="<li>You’re a mouse in this tiny maze. You always <strong>start at the same starting point.</strong></li> <li>The goal is <strong>to eat the big pile of cheese at the bottom right-hand corner</strong> and avoid the poison. After all, who doesn’t like cheese?</li> <li>The episode ends if we eat the poison, <strong>eat the big pile of cheese</strong>, or if we take more than five steps.</li> <li>The learning rate is 0.1</li> <li>The discount rate (gamma) is 0.99</li>",ut,S,ue,ht,C,he="The reward function goes like this:",ft,z,fe="<li><strong>+0:</strong> Going to a state with no cheese in it.</li> <li><strong>+1:</strong> Going to a state with a small cheese in it.</li> <li><strong>+10:</strong> Going to the state with the big pile of cheese.</li> <li><strong>-10:</strong> Going to the state with the poison and thus dying.</li> <li><strong>+0</strong> If we take more than five steps.</li>",vt,I,ve,dt,L,de="To train our agent to have an optimal policy (so a policy that goes right, right, down), <strong>we will use the Q-Learning algorithm</strong>.",xt,E,wt,P,xe,_t,H,we="So, for now, <strong>our Q-table is useless</strong>; we need <strong>to train our Q-function using the Q-Learning algorithm.</strong>",$t,k,_e="Let’s do it for 2 training timesteps:",yt,G,$e="Training timestep 1:",Mt,Q,bt,A,ye="Because epsilon is big (= 1.0), I take a random action. In this case, I go right.",Tt,q,Me,St,j,Ct,u,se,zt,Ge='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',It,Lt,R,be,Et,B,Pt,h,ae,Ht,Qe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',kt,Gt,U,Te,Qt,N,Se,At,W,Ce="Training timestep 2:",qt,Y,jt,D,ze="<strong>I take a random action again, since epsilon=0.99 is big</strong>. (Notice we decay epsilon a little bit because, as the training progress, we want less and less exploration).",Rt,O,Ie="I took the action ‘down’. <strong>This is not a good action since it leads me to the poison.</strong>",Bt,F,Le,Ut,J,Nt,K,ne,V,le,Wt,Ae='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mo>−</mo><mn>10</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = -10</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">−</span><span class="mord">10</span></span></span></span>',Yt,Dt,X,Ee,Ot,Z,Ft,tt,Pe,Jt,et,He="Because we’re dead, we start a new episode. But what we see here is that, <strong>with two explorations steps, my agent became smarter.</strong>",Kt,st,ke="As we continue exploring and exploiting the environment and updating Q-values using the TD target, the <strong>Q-table will give us a better and better approximation. At the end of the training, we’ll get an estimate of the optimal Q-function.</strong>",Vt,pt,Xt;return y=new $({props:{title:"A Q-Learning example",local:"q-learning-example",headingTag:"h1"}}),E=new $({props:{title:"Step 1: Initialize the Q-table",local:"step1",headingTag:"h2"}}),Q=new $({props:{title:"Step 2: Choose an action using the Epsilon Greedy Strategy",local:"step2",headingTag:"h2"}}),j=new $({props:{title:"Step 3: Perform action At, get Rt+1 and St+1",local:"step3",headingTag:"h2"}}),B=new $({props:{title:"Step 4: Update Q(St, At)",local:"step4",headingTag:"h2"}}),Y=new $({props:{title:"Step 2: Choose an action using the Epsilon Greedy Strategy",local:"step2-2",headingTag:"h2"}}),J=new $({props:{title:"Step 3: Perform action At, get Rt+1 and St+1",local:"step3-3",headingTag:"h2"}}),Z=new $({props:{title:"Step 4: Update Q(St, At)",local:"step4-4",headingTag:"h2"}}),{c(){o=i("meta"),mt=n(),it=i("p"),rt=n(),f(y.$$.fragment),gt=n(),M=i("p"),M.textContent=ge,ot=n(),b=i("img"),ct=n(),T=i("ul"),T.innerHTML=ce,ut=n(),S=i("img"),ht=n(),C=i("p"),C.textContent=he,ft=n(),z=i("ul"),z.innerHTML=fe,vt=n(),I=i("img"),dt=n(),L=i("p"),L.innerHTML=de,xt=n(),f(E.$$.fragment),wt=n(),P=i("img"),_t=n(),H=i("p"),H.innerHTML=we,$t=n(),k=i("p"),k.textContent=_e,yt=n(),G=i("p"),G.textContent=$e,Mt=n(),f(Q.$$.fragment),bt=n(),A=i("p"),A.textContent=ye,Tt=n(),q=i("img"),St=n(),f(j.$$.fragment),Ct=n(),u=i("p"),se=at("By going right, I get a small cheese, so "),zt=new pe(!1),It=at(" and I’m in a new state."),Lt=n(),R=i("img"),Et=n(),f(B.$$.fragment),Pt=n(),h=i("p"),ae=at("We can now update "),Ht=new pe(!1),kt=at(" using our formula."),Gt=n(),U=i("img"),Qt=n(),N=i("img"),At=n(),W=i("p"),W.textContent=Ce,qt=n(),f(Y.$$.fragment),jt=n(),D=i("p"),D.innerHTML=ze,Rt=n(),O=i("p"),O.innerHTML=Ie,Bt=n(),F=i("img"),Ut=n(),f(J.$$.fragment),Nt=n(),K=i("p"),ne=at("Because I ate poison, "),V=i("strong"),le=at("I get "),Wt=new pe(!1),Yt=at(", and I die."),Dt=n(),X=i("img"),Ot=n(),f(Z.$$.fragment),Ft=n(),tt=i("img"),Jt=n(),et=i("p"),et.innerHTML=He,Kt=n(),st=i("p"),st.innerHTML=ke,Vt=n(),pt=i("p"),this.h()},l(t){const e=Ne("svelte-u9bgzb",document.head);o=p(e,"META",{name:!0,content:!0}),e.forEach(s),mt=l(t),it=p(t,"P",{}),lt(it).forEach(s),rt=l(t),v(y.$$.fragment,t),gt=l(t),M=p(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-9fmuny"&&(M.textContent=ge),ot=l(t),b=p(t,"IMG",{src:!0,alt:!0}),ct=l(t),T=p(t,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-n6lz09"&&(T.innerHTML=ce),ut=l(t),S=p(t,"IMG",{src:!0,alt:!0}),ht=l(t),C=p(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-dok1jh"&&(C.textContent=he),ft=l(t),z=p(t,"UL",{"data-svelte-h":!0}),r(z)!=="svelte-93cdg2"&&(z.innerHTML=fe),vt=l(t),I=p(t,"IMG",{src:!0,alt:!0}),dt=l(t),L=p(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-pbs6nn"&&(L.innerHTML=de),xt=l(t),v(E.$$.fragment,t),wt=l(t),P=p(t,"IMG",{src:!0,alt:!0}),_t=l(t),H=p(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-9m32nr"&&(H.innerHTML=we),$t=l(t),k=p(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-29jh6q"&&(k.textContent=_e),yt=l(t),G=p(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-51ll5c"&&(G.textContent=$e),Mt=l(t),v(Q.$$.fragment,t),bt=l(t),A=p(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1hg390z"&&(A.textContent=ye),Tt=l(t),q=p(t,"IMG",{src:!0,alt:!0}),St=l(t),v(j.$$.fragment,t),Ct=l(t),u=p(t,"P",{});var Zt=lt(u);se=nt(Zt,"By going right, I get a small cheese, so "),zt=me(Zt,!1),It=nt(Zt," and I’m in a new state."),Zt.forEach(s),Lt=l(t),R=p(t,"IMG",{src:!0,alt:!0}),Et=l(t),v(B.$$.fragment,t),Pt=l(t),h=p(t,"P",{});var te=lt(h);ae=nt(te,"We can now update "),Ht=me(te,!1),kt=nt(te," using our formula."),te.forEach(s),Gt=l(t),U=p(t,"IMG",{src:!0,alt:!0}),Qt=l(t),N=p(t,"IMG",{src:!0,alt:!0}),At=l(t),W=p(t,"P",{"data-svelte-h":!0}),r(W)!=="svelte-120ic1h"&&(W.textContent=Ce),qt=l(t),v(Y.$$.fragment,t),jt=l(t),D=p(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-14kapt5"&&(D.innerHTML=ze),Rt=l(t),O=p(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-7qp2oa"&&(O.innerHTML=Ie),Bt=l(t),F=p(t,"IMG",{src:!0,alt:!0}),Ut=l(t),v(J.$$.fragment,t),Nt=l(t),K=p(t,"P",{});var ie=lt(K);ne=nt(ie,"Because I ate poison, "),V=p(ie,"STRONG",{});var ee=lt(V);le=nt(ee,"I get "),Wt=me(ee,!1),Yt=nt(ee,", and I die."),ee.forEach(s),ie.forEach(s),Dt=l(t),X=p(t,"IMG",{src:!0,alt:!0}),Ot=l(t),v(Z.$$.fragment,t),Ft=l(t),tt=p(t,"IMG",{src:!0,alt:!0}),Jt=l(t),et=p(t,"P",{"data-svelte-h":!0}),r(et)!=="svelte-1heq24d"&&(et.innerHTML=He),Kt=l(t),st=p(t,"P",{"data-svelte-h":!0}),r(st)!=="svelte-1eluo1b"&&(st.innerHTML=ke),Vt=l(t),pt=p(t,"P",{}),lt(pt).forEach(s),this.h()},h(){m(o,"name","hf:doc:metadata"),m(o,"content",Ye),g(b.src,oe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-Example-2.jpg")||m(b,"src",oe),m(b,"alt","Maze-Example"),g(S.src,ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-1.jpg")||m(S,"src",ue),m(S,"alt","Maze-Example"),g(I.src,ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-2.jpg")||m(I,"src",ve),m(I,"alt","Maze-Example"),g(P.src,xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-1.jpg")||m(P,"src",xe),m(P,"alt","Maze-Example"),g(q.src,Me="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-3.jpg")||m(q,"src",Me),m(q,"alt","Maze-Example"),zt.a=It,g(R.src,be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-4.jpg")||m(R,"src",be),m(R,"alt","Maze-Example"),Ht.a=kt,g(U.src,Te="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-5.jpg")||m(U,"src",Te),m(U,"alt","Maze-Example"),g(N.src,Se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-4.jpg")||m(N,"src",Se),m(N,"alt","Maze-Example"),g(F.src,Le="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-6.jpg")||m(F,"src",Le),m(F,"alt","Maze-Example"),Wt.a=Yt,g(X.src,Ee="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-7.jpg")||m(X,"src",Ee),m(X,"alt","Maze-Example"),g(tt.src,Pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-8.jpg")||m(tt,"src",Pe),m(tt,"alt","Maze-Example")},m(t,e){c(document.head,o),a(t,mt,e),a(t,it,e),a(t,rt,e),d(y,t,e),a(t,gt,e),a(t,M,e),a(t,ot,e),a(t,b,e),a(t,ct,e),a(t,T,e),a(t,ut,e),a(t,S,e),a(t,ht,e),a(t,C,e),a(t,ft,e),a(t,z,e),a(t,vt,e),a(t,I,e),a(t,dt,e),a(t,L,e),a(t,xt,e),d(E,t,e),a(t,wt,e),a(t,P,e),a(t,_t,e),a(t,H,e),a(t,$t,e),a(t,k,e),a(t,yt,e),a(t,G,e),a(t,Mt,e),d(Q,t,e),a(t,bt,e),a(t,A,e),a(t,Tt,e),a(t,q,e),a(t,St,e),d(j,t,e),a(t,Ct,e),a(t,u,e),c(u,se),zt.m(Ge,u),c(u,It),a(t,Lt,e),a(t,R,e),a(t,Et,e),d(B,t,e),a(t,Pt,e),a(t,h,e),c(h,ae),Ht.m(Qe,h),c(h,kt),a(t,Gt,e),a(t,U,e),a(t,Qt,e),a(t,N,e),a(t,At,e),a(t,W,e),a(t,qt,e),d(Y,t,e),a(t,jt,e),a(t,D,e),a(t,Rt,e),a(t,O,e),a(t,Bt,e),a(t,F,e),a(t,Ut,e),d(J,t,e),a(t,Nt,e),a(t,K,e),c(K,ne),c(K,V),c(V,le),Wt.m(Ae,V),c(V,Yt),a(t,Dt,e),a(t,X,e),a(t,Ot,e),d(Z,t,e),a(t,Ft,e),a(t,tt,e),a(t,Jt,e),a(t,et,e),a(t,Kt,e),a(t,st,e),a(t,Vt,e),a(t,pt,e),Xt=!0},p:je,i(t){Xt||(x(y.$$.fragment,t),x(E.$$.fragment,t),x(Q.$$.fragment,t),x(j.$$.fragment,t),x(B.$$.fragment,t),x(Y.$$.fragment,t),x(J.$$.fragment,t),x(Z.$$.fragment,t),Xt=!0)},o(t){w(y.$$.fragment,t),w(E.$$.fragment,t),w(Q.$$.fragment,t),w(j.$$.fragment,t),w(B.$$.fragment,t),w(Y.$$.fragment,t),w(J.$$.fragment,t),w(Z.$$.fragment,t),Xt=!1},d(t){t&&(s(mt),s(it),s(rt),s(gt),s(M),s(ot),s(b),s(ct),s(T),s(ut),s(S),s(ht),s(C),s(ft),s(z),s(vt),s(I),s(dt),s(L),s(xt),s(wt),s(P),s(_t),s(H),s($t),s(k),s(yt),s(G),s(Mt),s(bt),s(A),s(Tt),s(q),s(St),s(Ct),s(u),s(Lt),s(R),s(Et),s(Pt),s(h),s(Gt),s(U),s(Qt),s(N),s(At),s(W),s(qt),s(jt),s(D),s(Rt),s(O),s(Bt),s(F),s(Ut),s(Nt),s(K),s(Dt),s(X),s(Ot),s(Ft),s(tt),s(Jt),s(et),s(Kt),s(st),s(Vt),s(pt)),s(o),_(y,t),_(E,t),_(Q,t),_(j,t),_(B,t),_(Y,t),_(J,t),_(Z,t)}}}const Ye='{"title":"A Q-Learning example","local":"q-learning-example","sections":[{"title":"Step 1: Initialize the Q-table","local":"step1","sections":[],"depth":2},{"title":"Step 2: Choose an action using the Epsilon Greedy Strategy","local":"step2","sections":[],"depth":2},{"title":"Step 3: Perform action At, get Rt+1 and St+1","local":"step3","sections":[],"depth":2},{"title":"Step 4: Update Q(St, At)","local":"step4","sections":[],"depth":2},{"title":"Step 2: Choose an action using the Epsilon Greedy Strategy","local":"step2-2","sections":[],"depth":2},{"title":"Step 3: Perform action At, get Rt+1 and St+1","local":"step3-3","sections":[],"depth":2},{"title":"Step 4: Update Q(St, At)","local":"step4-4","sections":[],"depth":2}],"depth":1}';function De(re){return Re(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ke extends Be{constructor(o){super(),Ue(this,o,De,We,qe,{})}}export{Ke as component};
