import{s as Ae,f as E,n as Le,o as Te}from"../chunks/scheduler.37c15a92.js";import{S as ze,i as $e,g as n,s as p,r as Dt,m as c,H as u,A as Pe,h as l,f as t,c as m,j as h,u as Jt,x as r,n as o,B as v,k as g,y as i,a as e,v as Kt,d as Xt,t as Zt,w as sa}from"../chunks/index.7cb9c9b8.js";import{H as ta}from"../chunks/Heading.d3928e2a.js";function Ee(Ca){let x,Is,Ts,qs,S,js,H,Gs,I,ba="The solution to reducing the variance of the Reinforce algorithm and training our agent faster and better is to use a combination of Policy-Based and Value-Based methods: <em>the Actor-Critic method</em>.",Rs,q,Ma="To understand the Actor-Critic, imagine you’re playing a video game. You can play with a friend that will provide you with some feedback. You’re the Actor and your friend is the Critic.",Os,j,ka,Us,G,Aa="You don’t know how to play at the beginning, <strong>so you try some actions randomly</strong>. The Critic observes your action and <strong>provides feedback</strong>.",Ns,R,La="Learning from this feedback, <strong>you’ll update your policy and be better at playing that game.</strong>",Qs,O,Ta="On the other hand, your friend (Critic) will also update their way to provide feedback so it can be better next time.",Fs,U,za="This is the idea behind Actor-Critic. We learn two function approximations:",Vs,A,zs,y,ms,$a="A policy",aa,rs,Pa="controls how our agent acts",ea,Bs,oe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',na,$s,N,cs,Ea="A value function",la,Ys,he='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',Ws,Q,Ds,F,Sa="Now that we have seen the Actor Critic’s big picture, let’s dive deeper to understand how the Actor and Critic improve together during the training.",Js,V,Ha="As we saw, with Actor-Critic methods, there are two function approximations (two neural networks):",Ks,L,_,os,Ia="Actor",ia,hs,qa="policy function",pa,Xs,ge='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',ma,C,gs,ja="Critic",ra,us,Ga="value function",ca,Zs,ue='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',st,B,Ra="Let’s see the training process to understand how the Actor and Critic are optimized:",tt,T,Ps,b,oa,at,ve='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',et,vs,Oa="pass it as input through our Actor and Critic",ha,ga,Es,M,ua,ds,Ua="outputs an action",va,nt,de='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',lt,it,Y,Na,pt,fs,d,da,mt,fe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',rt,ct,we='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ot,ws,Qa="computes the value of taking that action at that state: the Q-value",fa,ht,W,Fa,gt,xs,f,wa,ut,xe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',vt,dt,ye='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',ft,wt,_e='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> R_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',xt,yt,D,Va,_t,J,Ba="<li>The Actor updates its policy parameters using the Q value.</li>",Ct,K,Ya,bt,z,Ss,k,xa,Mt,Ce='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> A_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',kt,At,be='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1} </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Lt,ya,ys,Wa="<p>The Critic then updates its value parameters.</p>",Tt,X,Da,zt,Z,$t,ss,Ja="We can stabilize learning further by <strong>using the Advantage function as Critic instead of the Action value function</strong>.",Pt,ts,Ka="The idea is that the Advantage function calculates the relative advantage of an action compared to the others possible at a state: <strong>how taking that action at a state is better compared to the average value of the state</strong>. It’s subtracting the mean value of the state from the state action pair:",Et,as,Xa,St,es,Za="In other words, this function calculates <strong>the extra reward we get if we take this action at that state compared to the mean reward we get at that state</strong>.",Ht,ns,se="The extra reward is what’s beyond the expected value of that state.",It,ls,te="<li>If A(s,a) &gt; 0: our gradient is <strong>pushed in that direction</strong>.</li> <li>If A(s,a) &lt; 0 (our action does worse than the average value of that state), <strong>our gradient is pushed in the opposite direction</strong>.</li>",qt,w,_a,jt,Me='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> Q(s,a)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',Gt,Rt,ke='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> V(s)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',Ot,_s,ae="we can use the TD error as a good estimator of the advantage function.",Ut,is,ee,Nt,Hs,Qt;return S=new ta({props:{title:"Advantage Actor-Critic (A2C)",local:"advantage-actor-critic",headingTag:"h1"}}),H=new ta({props:{title:"Reducing variance with Actor-Critic methods",local:"reducing-variance-with-actor-critic-methods",headingTag:"h2"}}),Q=new ta({props:{title:"The Actor-Critic Process",local:"the-actor-critic-process",headingTag:"h2"}}),Z=new ta({props:{title:"Adding Advantage in Actor-Critic (A2C)",local:"adding-advantage-in-actor-critic-a2c",headingTag:"h2"}}),{c(){x=n("meta"),Is=p(),Ts=n("p"),qs=p(),Dt(S.$$.fragment),js=p(),Dt(H.$$.fragment),Gs=p(),I=n("p"),I.innerHTML=ba,Rs=p(),q=n("p"),q.textContent=Ma,Os=p(),j=n("img"),Us=p(),G=n("p"),G.innerHTML=Aa,Ns=p(),R=n("p"),R.innerHTML=La,Qs=p(),O=n("p"),O.textContent=Ta,Fs=p(),U=n("p"),U.textContent=za,Vs=p(),A=n("ul"),zs=n("li"),y=n("p"),ms=n("em"),ms.textContent=$a,aa=c(" that "),rs=n("strong"),rs.textContent=Pa,ea=c(": "),Bs=new u(!1),na=p(),$s=n("li"),N=n("p"),cs=n("em"),cs.textContent=Ea,la=c(" to assist the policy update by measuring how good the action taken is: "),Ys=new u(!1),Ws=p(),Dt(Q.$$.fragment),Ds=p(),F=n("p"),F.textContent=Sa,Js=p(),V=n("p"),V.textContent=Ha,Ks=p(),L=n("ul"),_=n("li"),os=n("em"),os.textContent=Ia,ia=c(", a "),hs=n("strong"),hs.textContent=qa,pa=c(" parameterized by theta: "),Xs=new u(!1),ma=p(),C=n("li"),gs=n("em"),gs.textContent=ja,ra=c(", a "),us=n("strong"),us.textContent=Ga,ca=c(" parameterized by w: "),Zs=new u(!1),st=p(),B=n("p"),B.textContent=Ra,tt=p(),T=n("ul"),Ps=n("li"),b=n("p"),oa=c("At each timestep, t, we get the current state "),at=new u(!1),et=c(" from the environment and "),vs=n("strong"),vs.textContent=Oa,ha=c("."),ga=p(),Es=n("li"),M=n("p"),ua=c("Our Policy takes the state and "),ds=n("strong"),ds.textContent=Ua,va=p(),nt=new u(!1),lt=c("."),it=p(),Y=n("img"),pt=p(),fs=n("ul"),d=n("li"),da=c("The Critic takes that action also as input and, using "),mt=new u(!1),rt=c(" and "),ct=new u(!1),ot=c(", "),ws=n("strong"),ws.textContent=Qa,fa=c("."),ht=p(),W=n("img"),gt=p(),xs=n("ul"),f=n("li"),wa=c("The action "),ut=new u(!1),vt=c(" performed in the environment outputs a new state "),dt=new u(!1),ft=c(" and a reward "),wt=new u(!1),xt=c(" ."),yt=p(),D=n("img"),_t=p(),J=n("ul"),J.innerHTML=Ba,Ct=p(),K=n("img"),bt=p(),z=n("ul"),Ss=n("li"),k=n("p"),xa=c("Thanks to its updated parameters, the Actor produces the next action to take at "),Mt=new u(!1),kt=c(" given the new state "),At=new u(!1),Lt=c("."),ya=p(),ys=n("li"),ys.innerHTML=Wa,Tt=p(),X=n("img"),zt=p(),Dt(Z.$$.fragment),$t=p(),ss=n("p"),ss.innerHTML=Ja,Pt=p(),ts=n("p"),ts.innerHTML=Ka,Et=p(),as=n("img"),St=p(),es=n("p"),es.innerHTML=Za,Ht=p(),ns=n("p"),ns.textContent=se,It=p(),ls=n("ul"),ls.innerHTML=te,qt=p(),w=n("p"),_a=c("The problem with implementing this advantage function is that it requires two value functions —  "),jt=new u(!1),Gt=c(" and  "),Rt=new u(!1),Ot=c(". Fortunately, "),_s=n("strong"),_s.textContent=ae,Ut=p(),is=n("img"),Nt=p(),Hs=n("p"),this.h()},l(s){const a=Pe("svelte-u9bgzb",document.head);x=l(a,"META",{name:!0,content:!0}),a.forEach(t),Is=m(s),Ts=l(s,"P",{}),h(Ts).forEach(t),qs=m(s),Jt(S.$$.fragment,s),js=m(s),Jt(H.$$.fragment,s),Gs=m(s),I=l(s,"P",{"data-svelte-h":!0}),r(I)!=="svelte-krwho4"&&(I.innerHTML=ba),Rs=m(s),q=l(s,"P",{"data-svelte-h":!0}),r(q)!=="svelte-hd3rkl"&&(q.textContent=Ma),Os=m(s),j=l(s,"IMG",{src:!0,alt:!0}),Us=m(s),G=l(s,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1lbzw5w"&&(G.innerHTML=Aa),Ns=m(s),R=l(s,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1g68qqi"&&(R.innerHTML=La),Qs=m(s),O=l(s,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1i1ihbx"&&(O.textContent=Ta),Fs=m(s),U=l(s,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1fcp10q"&&(U.textContent=za),Vs=m(s),A=l(s,"UL",{});var Ft=h(A);zs=l(Ft,"LI",{});var ne=h(zs);y=l(ne,"P",{});var Cs=h(y);ms=l(Cs,"EM",{"data-svelte-h":!0}),r(ms)!=="svelte-1q5uc95"&&(ms.textContent=$a),aa=o(Cs," that "),rs=l(Cs,"STRONG",{"data-svelte-h":!0}),r(rs)!=="svelte-9j9b6"&&(rs.textContent=Pa),ea=o(Cs,": "),Bs=v(Cs,!1),Cs.forEach(t),ne.forEach(t),na=m(Ft),$s=l(Ft,"LI",{});var le=h($s);N=l(le,"P",{});var Vt=h(N);cs=l(Vt,"EM",{"data-svelte-h":!0}),r(cs)!=="svelte-1lxl85o"&&(cs.textContent=Ea),la=o(Vt," to assist the policy update by measuring how good the action taken is: "),Ys=v(Vt,!1),Vt.forEach(t),le.forEach(t),Ft.forEach(t),Ws=m(s),Jt(Q.$$.fragment,s),Ds=m(s),F=l(s,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1c7kje2"&&(F.textContent=Sa),Js=m(s),V=l(s,"P",{"data-svelte-h":!0}),r(V)!=="svelte-eu7748"&&(V.textContent=Ha),Ks=m(s),L=l(s,"UL",{});var Bt=h(L);_=l(Bt,"LI",{});var bs=h(_);os=l(bs,"EM",{"data-svelte-h":!0}),r(os)!=="svelte-1df5trl"&&(os.textContent=Ia),ia=o(bs,", a "),hs=l(bs,"STRONG",{"data-svelte-h":!0}),r(hs)!=="svelte-m02j94"&&(hs.textContent=qa),pa=o(bs," parameterized by theta: "),Xs=v(bs,!1),bs.forEach(t),ma=m(Bt),C=l(Bt,"LI",{});var Ms=h(C);gs=l(Ms,"EM",{"data-svelte-h":!0}),r(gs)!=="svelte-18wqahq"&&(gs.textContent=ja),ra=o(Ms,", a "),us=l(Ms,"STRONG",{"data-svelte-h":!0}),r(us)!=="svelte-1fbqdkf"&&(us.textContent=Ga),ca=o(Ms," parameterized by w: "),Zs=v(Ms,!1),Ms.forEach(t),Bt.forEach(t),st=m(s),B=l(s,"P",{"data-svelte-h":!0}),r(B)!=="svelte-qos3jx"&&(B.textContent=Ra),tt=m(s),T=l(s,"UL",{});var Yt=h(T);Ps=l(Yt,"LI",{});var ie=h(Ps);b=l(ie,"P",{});var ks=h(b);oa=o(ks,"At each timestep, t, we get the current state "),at=v(ks,!1),et=o(ks," from the environment and "),vs=l(ks,"STRONG",{"data-svelte-h":!0}),r(vs)!=="svelte-7r20hj"&&(vs.textContent=Oa),ha=o(ks,"."),ks.forEach(t),ie.forEach(t),ga=m(Yt),Es=l(Yt,"LI",{});var pe=h(Es);M=l(pe,"P",{});var As=h(M);ua=o(As,"Our Policy takes the state and "),ds=l(As,"STRONG",{"data-svelte-h":!0}),r(ds)!=="svelte-10nn435"&&(ds.textContent=Ua),va=m(As),nt=v(As,!1),lt=o(As,"."),As.forEach(t),pe.forEach(t),Yt.forEach(t),it=m(s),Y=l(s,"IMG",{src:!0,alt:!0}),pt=m(s),fs=l(s,"UL",{});var me=h(fs);d=l(me,"LI",{});var $=h(d);da=o($,"The Critic takes that action also as input and, using "),mt=v($,!1),rt=o($," and "),ct=v($,!1),ot=o($,", "),ws=l($,"STRONG",{"data-svelte-h":!0}),r(ws)!=="svelte-uggext"&&(ws.textContent=Qa),fa=o($,"."),$.forEach(t),me.forEach(t),ht=m(s),W=l(s,"IMG",{src:!0,alt:!0}),gt=m(s),xs=l(s,"UL",{});var re=h(xs);f=l(re,"LI",{});var P=h(f);wa=o(P,"The action "),ut=v(P,!1),vt=o(P," performed in the environment outputs a new state "),dt=v(P,!1),ft=o(P," and a reward "),wt=v(P,!1),xt=o(P," ."),P.forEach(t),re.forEach(t),yt=m(s),D=l(s,"IMG",{src:!0,alt:!0}),_t=m(s),J=l(s,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-1xd4i4c"&&(J.innerHTML=Ba),Ct=m(s),K=l(s,"IMG",{src:!0,alt:!0}),bt=m(s),z=l(s,"UL",{});var Wt=h(z);Ss=l(Wt,"LI",{});var ce=h(Ss);k=l(ce,"P",{});var Ls=h(k);xa=o(Ls,"Thanks to its updated parameters, the Actor produces the next action to take at "),Mt=v(Ls,!1),kt=o(Ls," given the new state "),At=v(Ls,!1),Lt=o(Ls,"."),Ls.forEach(t),ce.forEach(t),ya=m(Wt),ys=l(Wt,"LI",{"data-svelte-h":!0}),r(ys)!=="svelte-orop3a"&&(ys.innerHTML=Wa),Wt.forEach(t),Tt=m(s),X=l(s,"IMG",{src:!0,alt:!0}),zt=m(s),Jt(Z.$$.fragment,s),$t=m(s),ss=l(s,"P",{"data-svelte-h":!0}),r(ss)!=="svelte-e76jc2"&&(ss.innerHTML=Ja),Pt=m(s),ts=l(s,"P",{"data-svelte-h":!0}),r(ts)!=="svelte-1ihnygk"&&(ts.innerHTML=Ka),Et=m(s),as=l(s,"IMG",{src:!0,alt:!0}),St=m(s),es=l(s,"P",{"data-svelte-h":!0}),r(es)!=="svelte-1y9z9x3"&&(es.innerHTML=Za),Ht=m(s),ns=l(s,"P",{"data-svelte-h":!0}),r(ns)!=="svelte-102uivm"&&(ns.textContent=se),It=m(s),ls=l(s,"UL",{"data-svelte-h":!0}),r(ls)!=="svelte-9js17k"&&(ls.innerHTML=te),qt=m(s),w=l(s,"P",{});var ps=h(w);_a=o(ps,"The problem with implementing this advantage function is that it requires two value functions —  "),jt=v(ps,!1),Gt=o(ps," and  "),Rt=v(ps,!1),Ot=o(ps,". Fortunately, "),_s=l(ps,"STRONG",{"data-svelte-h":!0}),r(_s)!=="svelte-a0qaqz"&&(_s.textContent=ae),ps.forEach(t),Ut=m(s),is=l(s,"IMG",{src:!0,alt:!0}),Nt=m(s),Hs=l(s,"P",{}),h(Hs).forEach(t),this.h()},h(){g(x,"name","hf:doc:metadata"),g(x,"content",Se),E(j.src,ka="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/ac.jpg")||g(j,"src",ka),g(j,"alt","Actor Critic"),Bs.a=null,Ys.a=null,Xs.a=null,Zs.a=null,at.a=et,nt.a=lt,E(Y.src,Na="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step1.jpg")||g(Y,"src",Na),g(Y,"alt","Step 1 Actor Critic"),mt.a=rt,ct.a=ot,E(W.src,Fa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step2.jpg")||g(W,"src",Fa),g(W,"alt","Step 2 Actor Critic"),ut.a=vt,dt.a=ft,wt.a=xt,E(D.src,Va="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step3.jpg")||g(D,"src",Va),g(D,"alt","Step 3 Actor Critic"),E(K.src,Ya="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step4.jpg")||g(K,"src",Ya),g(K,"alt","Step 4 Actor Critic"),Mt.a=kt,At.a=Lt,E(X.src,Da="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step5.jpg")||g(X,"src",Da),g(X,"alt","Step 5 Actor Critic"),E(as.src,Xa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage1.jpg")||g(as,"src",Xa),g(as,"alt","Advantage Function"),jt.a=Gt,Rt.a=Ot,E(is.src,ee="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage2.jpg")||g(is,"src",ee),g(is,"alt","Advantage Function")},m(s,a){i(document.head,x),e(s,Is,a),e(s,Ts,a),e(s,qs,a),Kt(S,s,a),e(s,js,a),Kt(H,s,a),e(s,Gs,a),e(s,I,a),e(s,Rs,a),e(s,q,a),e(s,Os,a),e(s,j,a),e(s,Us,a),e(s,G,a),e(s,Ns,a),e(s,R,a),e(s,Qs,a),e(s,O,a),e(s,Fs,a),e(s,U,a),e(s,Vs,a),e(s,A,a),i(A,zs),i(zs,y),i(y,ms),i(y,aa),i(y,rs),i(y,ea),Bs.m(oe,y),i(A,na),i(A,$s),i($s,N),i(N,cs),i(N,la),Ys.m(he,N),e(s,Ws,a),Kt(Q,s,a),e(s,Ds,a),e(s,F,a),e(s,Js,a),e(s,V,a),e(s,Ks,a),e(s,L,a),i(L,_),i(_,os),i(_,ia),i(_,hs),i(_,pa),Xs.m(ge,_),i(L,ma),i(L,C),i(C,gs),i(C,ra),i(C,us),i(C,ca),Zs.m(ue,C),e(s,st,a),e(s,B,a),e(s,tt,a),e(s,T,a),i(T,Ps),i(Ps,b),i(b,oa),at.m(ve,b),i(b,et),i(b,vs),i(b,ha),i(T,ga),i(T,Es),i(Es,M),i(M,ua),i(M,ds),i(M,va),nt.m(de,M),i(M,lt),e(s,it,a),e(s,Y,a),e(s,pt,a),e(s,fs,a),i(fs,d),i(d,da),mt.m(fe,d),i(d,rt),ct.m(we,d),i(d,ot),i(d,ws),i(d,fa),e(s,ht,a),e(s,W,a),e(s,gt,a),e(s,xs,a),i(xs,f),i(f,wa),ut.m(xe,f),i(f,vt),dt.m(ye,f),i(f,ft),wt.m(_e,f),i(f,xt),e(s,yt,a),e(s,D,a),e(s,_t,a),e(s,J,a),e(s,Ct,a),e(s,K,a),e(s,bt,a),e(s,z,a),i(z,Ss),i(Ss,k),i(k,xa),Mt.m(Ce,k),i(k,kt),At.m(be,k),i(k,Lt),i(z,ya),i(z,ys),e(s,Tt,a),e(s,X,a),e(s,zt,a),Kt(Z,s,a),e(s,$t,a),e(s,ss,a),e(s,Pt,a),e(s,ts,a),e(s,Et,a),e(s,as,a),e(s,St,a),e(s,es,a),e(s,Ht,a),e(s,ns,a),e(s,It,a),e(s,ls,a),e(s,qt,a),e(s,w,a),i(w,_a),jt.m(Me,w),i(w,Gt),Rt.m(ke,w),i(w,Ot),i(w,_s),e(s,Ut,a),e(s,is,a),e(s,Nt,a),e(s,Hs,a),Qt=!0},p:Le,i(s){Qt||(Xt(S.$$.fragment,s),Xt(H.$$.fragment,s),Xt(Q.$$.fragment,s),Xt(Z.$$.fragment,s),Qt=!0)},o(s){Zt(S.$$.fragment,s),Zt(H.$$.fragment,s),Zt(Q.$$.fragment,s),Zt(Z.$$.fragment,s),Qt=!1},d(s){s&&(t(Is),t(Ts),t(qs),t(js),t(Gs),t(I),t(Rs),t(q),t(Os),t(j),t(Us),t(G),t(Ns),t(R),t(Qs),t(O),t(Fs),t(U),t(Vs),t(A),t(Ws),t(Ds),t(F),t(Js),t(V),t(Ks),t(L),t(st),t(B),t(tt),t(T),t(it),t(Y),t(pt),t(fs),t(ht),t(W),t(gt),t(xs),t(yt),t(D),t(_t),t(J),t(Ct),t(K),t(bt),t(z),t(Tt),t(X),t(zt),t($t),t(ss),t(Pt),t(ts),t(Et),t(as),t(St),t(es),t(Ht),t(ns),t(It),t(ls),t(qt),t(w),t(Ut),t(is),t(Nt),t(Hs)),t(x),sa(S,s),sa(H,s),sa(Q,s),sa(Z,s)}}}const Se='{"title":"Advantage Actor-Critic (A2C)","local":"advantage-actor-critic","sections":[{"title":"Reducing variance with Actor-Critic methods","local":"reducing-variance-with-actor-critic-methods","sections":[],"depth":2},{"title":"The Actor-Critic Process","local":"the-actor-critic-process","sections":[],"depth":2},{"title":"Adding Advantage in Actor-Critic (A2C)","local":"adding-advantage-in-actor-critic-a2c","sections":[],"depth":2}],"depth":1}';function He(Ca){return Te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ge extends ze{constructor(x){super(),$e(this,x,He,Ee,Ae,{})}}export{Ge as component};
